<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UploadAttachmentResponse StructType
 * @subpackage Structs
 */
class UploadAttachmentResponse extends AbstractStructBase
{
    /**
     * The StatusCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $StatusCode;
    /**
     * The ErrorCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ErrorCode;
    /**
     * The UploadAttachmentResult
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\UploadAttachmentResponse
     */
    public $UploadAttachmentResult;
    /**
     * The AttachmentInternalId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AttachmentInternalId;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Status;
    /**
     * The Error
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Error;
    /**
     * Constructor method for UploadAttachmentResponse
     * @uses UploadAttachmentResponse::setStatusCode()
     * @uses UploadAttachmentResponse::setErrorCode()
     * @uses UploadAttachmentResponse::setUploadAttachmentResult()
     * @uses UploadAttachmentResponse::setAttachmentInternalId()
     * @uses UploadAttachmentResponse::setStatus()
     * @uses UploadAttachmentResponse::setError()
     * @param int $statusCode
     * @param int $errorCode
     * @param \eBizCharge\StructType\UploadAttachmentResponse $uploadAttachmentResult
     * @param string $attachmentInternalId
     * @param string $status
     * @param string $error
     */
    public function __construct($statusCode = null, $errorCode = null, \eBizCharge\StructType\UploadAttachmentResponse $uploadAttachmentResult = null, $attachmentInternalId = null, $status = null, $error = null)
    {
        $this
            ->setStatusCode($statusCode)
            ->setErrorCode($errorCode)
            ->setUploadAttachmentResult($uploadAttachmentResult)
            ->setAttachmentInternalId($attachmentInternalId)
            ->setStatus($status)
            ->setError($error);
    }
    /**
     * Get StatusCode value
     * @return int
     */
    public function getStatusCode()
    {
        return $this->StatusCode;
    }
    /**
     * Set StatusCode value
     * @param int $statusCode
     * @return \eBizCharge\StructType\UploadAttachmentResponse
     */
    public function setStatusCode($statusCode = null)
    {
        // validation for constraint: int
        if (!is_null($statusCode) && !(is_int($statusCode) || ctype_digit($statusCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusCode, true), gettype($statusCode)), __LINE__);
        }
        $this->StatusCode = $statusCode;
        return $this;
    }
    /**
     * Get ErrorCode value
     * @return int
     */
    public function getErrorCode()
    {
        return $this->ErrorCode;
    }
    /**
     * Set ErrorCode value
     * @param int $errorCode
     * @return \eBizCharge\StructType\UploadAttachmentResponse
     */
    public function setErrorCode($errorCode = null)
    {
        // validation for constraint: int
        if (!is_null($errorCode) && !(is_int($errorCode) || ctype_digit($errorCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($errorCode, true), gettype($errorCode)), __LINE__);
        }
        $this->ErrorCode = $errorCode;
        return $this;
    }
    /**
     * Get UploadAttachmentResult value
     * @return \eBizCharge\StructType\UploadAttachmentResponse|null
     */
    public function getUploadAttachmentResult()
    {
        return $this->UploadAttachmentResult;
    }
    /**
     * Set UploadAttachmentResult value
     * @param \eBizCharge\StructType\UploadAttachmentResponse $uploadAttachmentResult
     * @return \eBizCharge\StructType\UploadAttachmentResponse
     */
    public function setUploadAttachmentResult(\eBizCharge\StructType\UploadAttachmentResponse $uploadAttachmentResult = null)
    {
        $this->UploadAttachmentResult = $uploadAttachmentResult;
        return $this;
    }
    /**
     * Get AttachmentInternalId value
     * @return string|null
     */
    public function getAttachmentInternalId()
    {
        return $this->AttachmentInternalId;
    }
    /**
     * Set AttachmentInternalId value
     * @param string $attachmentInternalId
     * @return \eBizCharge\StructType\UploadAttachmentResponse
     */
    public function setAttachmentInternalId($attachmentInternalId = null)
    {
        // validation for constraint: string
        if (!is_null($attachmentInternalId) && !is_string($attachmentInternalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($attachmentInternalId, true), gettype($attachmentInternalId)), __LINE__);
        }
        $this->AttachmentInternalId = $attachmentInternalId;
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \eBizCharge\StructType\UploadAttachmentResponse
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get Error value
     * @return string|null
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * Set Error value
     * @param string $error
     * @return \eBizCharge\StructType\UploadAttachmentResponse
     */
    public function setError($error = null)
    {
        // validation for constraint: string
        if (!is_null($error) && !is_string($error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($error, true), gettype($error)), __LINE__);
        }
        $this->Error = $error;
        return $this;
    }
}
