<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserListSearchResult StructType
 * @subpackage Structs
 */
class UserListSearchResult extends AbstractStructBase
{
    /**
     * The Start
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Start;
    /**
     * The Limit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Limit;
    /**
     * The Count
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Count;
    /**
     * The UserList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\ArrayType\ArrayOfUserData
     */
    public $UserList;
    /**
     * Constructor method for UserListSearchResult
     * @uses UserListSearchResult::setStart()
     * @uses UserListSearchResult::setLimit()
     * @uses UserListSearchResult::setCount()
     * @uses UserListSearchResult::setUserList()
     * @param int $start
     * @param int $limit
     * @param int $count
     * @param \eBizCharge\ArrayType\ArrayOfUserData $userList
     */
    public function __construct($start = null, $limit = null, $count = null, \eBizCharge\ArrayType\ArrayOfUserData $userList = null)
    {
        $this
            ->setStart($start)
            ->setLimit($limit)
            ->setCount($count)
            ->setUserList($userList);
    }
    /**
     * Get Start value
     * @return int
     */
    public function getStart()
    {
        return $this->Start;
    }
    /**
     * Set Start value
     * @param int $start
     * @return \eBizCharge\StructType\UserListSearchResult
     */
    public function setStart($start = null)
    {
        // validation for constraint: int
        if (!is_null($start) && !(is_int($start) || ctype_digit($start))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($start, true), gettype($start)), __LINE__);
        }
        $this->Start = $start;
        return $this;
    }
    /**
     * Get Limit value
     * @return int
     */
    public function getLimit()
    {
        return $this->Limit;
    }
    /**
     * Set Limit value
     * @param int $limit
     * @return \eBizCharge\StructType\UserListSearchResult
     */
    public function setLimit($limit = null)
    {
        // validation for constraint: int
        if (!is_null($limit) && !(is_int($limit) || ctype_digit($limit))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($limit, true), gettype($limit)), __LINE__);
        }
        $this->Limit = $limit;
        return $this;
    }
    /**
     * Get Count value
     * @return int
     */
    public function getCount()
    {
        return $this->Count;
    }
    /**
     * Set Count value
     * @param int $count
     * @return \eBizCharge\StructType\UserListSearchResult
     */
    public function setCount($count = null)
    {
        // validation for constraint: int
        if (!is_null($count) && !(is_int($count) || ctype_digit($count))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($count, true), gettype($count)), __LINE__);
        }
        $this->Count = $count;
        return $this;
    }
    /**
     * Get UserList value
     * @return \eBizCharge\ArrayType\ArrayOfUserData|null
     */
    public function getUserList()
    {
        return $this->UserList;
    }
    /**
     * Set UserList value
     * @param \eBizCharge\ArrayType\ArrayOfUserData $userList
     * @return \eBizCharge\StructType\UserListSearchResult
     */
    public function setUserList(\eBizCharge\ArrayType\ArrayOfUserData $userList = null)
    {
        $this->UserList = $userList;
        return $this;
    }
}
